//
//  YHHomeBannerCollectionViewCell.swift
//  galaxy
//
//  Created by davidhuangA on 2024/4/12.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit
import FSPagerView

import CoreImage

class YHHomeBannerCollectionViewCell: FSPagerViewCell {
    override init(frame: CGRect) {
        super.init(frame: frame)
        textLabel?.text = ""
        textLabel?.isHidden = true
        imageView?.isHidden = true
        
        initView()
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    lazy var bannerImagV: UIImageView = {
        let imagV : UIImageView = UIImageView()
        imagV.contentMode = .scaleAspectFill
        imagV.clipsToBounds = true
        imagV.image = UIImage(named: "global_default_image")
        return imagV
    }()
    
    lazy var bannerTitleLable: UILabel = {
        let lable = UILabel()
        lable.font = UIFont.PFSC_R(ofSize: 16)
        lable.textColor = UIColor.white
        return lable
    }()
    
    
    lazy var effectV : UIVisualEffectView = {
        let effect = UIBlurEffect(style: .light)
        let effectV = UIVisualEffectView.init(effect: effect)
        return effectV
    }()
    
    
    lazy var effectVImageView : UIImageView = {
        let imageView = UIImageView()
        imageView.contentMode = .scaleAspectFit
//        let effectV = UIVisualEffectView.init(effect: effect)
        return imageView
    }()
    
    var dataModel : YHBannerModel? {
        didSet {
            updateUI()
        }
    }
}

private extension YHHomeBannerCollectionViewCell {
    
//    func makeBlurImage() -> UIImage {
////        let yourImage = UIImage.from(color: UIColor(hex: 0xff0000, alpha: 1))
//        let yourImage = UIImage(color: UIColor(hex: 0xffffff, alpha: 0.92), size: CGSize(width: KScreenWidth, height: 77))
//        
//        // 获取需要模糊的图像
//        let imageToBlur = CIImage(image: yourImage)
//
//        // 创建高斯模糊滤镜
//        let blurFilter = CIFilter(name: "CIGaussianBlur")
//        blurFilter?.setValue(imageToBlur, forKey: kCIInputImageKey)
//        blurFilter?.setValue(0.05, forKey: kCIInputRadiusKey) // 调整模糊的强度
//
//        // 获取模糊后的图像
//        let blurredImage = blurFilter?.outputImage
//
//        // 将模糊后的图像转换为UIImage
//        let context = CIContext(options: nil)
//        let cgImage = context.createCGImage(blurredImage!, from: blurredImage!.extent)
//        let finalImage = UIImage(cgImage: cgImage!)
//
//        // 在UIImageView中显示模糊后的图像
////        let blurredImageView = UIImageView(image: finalImage)
//        return finalImage
//    }
    
    func initView() {
        contentView.addSubview(bannerImagV)
        bannerImagV.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
        contentView.addSubview(effectV)
        effectV.snp.makeConstraints { make in
            make.bottom.left.right.equalToSuperview()
            make.height.equalTo(77)
        }
        
//        
//        effectVImageView.image = makeBlurImage()
//        contentView.addSubview(effectVImageView)
//        effectVImageView.snp.makeConstraints { make in
//            make.bottom.left.right.equalToSuperview()
//            make.height.equalTo(77)
//        }
//        
        
        contentView.addSubview(bannerTitleLable)
        bannerTitleLable.snp.makeConstraints { make in
            make.right.equalTo(-20)
            make.bottom.equalTo(-35)
            make.left.equalTo(20)
            make.height.equalTo(22)
        }
    }
    
    func updateUI() {
        guard let model = dataModel else { return }
        
        if model.isLocalItemFlag {
            bannerTitleLable.isHidden = true
            effectV.isHidden = true
            
            bannerImagV.image = UIImage(named: model.img_url)
        } else {
            bannerTitleLable.isHidden = false
            effectV.isHidden = false
            
            if let url = URL(string: model.img_url) {
                bannerImagV.kf.setImage(with: url, placeholder: UIImage(named: "global_default_image"))
            } else {
                bannerImagV.image = UIImage(named: "global_default_image")
            }
            bannerTitleLable.text = model.name
        }
    }
}
